clang-tools 6.0.0

Public Member Functions | List of all members
clang::tidy::cppcoreguidelines::OwningMemoryCheck Class Reference

Checks for common use cases for gsl::owner and enforces the unique owner nature of it whenever possible. More...

`#include <OwningMemoryCheck.h>`

Inheritance diagram for clang::tidy::cppcoreguidelines::OwningMemoryCheck:
[legend]
Collaboration diagram for clang::tidy::cppcoreguidelines::OwningMemoryCheck:
[legend]

## Public Member Functions
| OwningMemoryCheck (StringRef Name, ClangTidyContext *Context)
void | storeOptions (ClangTidyOptions::OptionMap &Opts) override
| Make configuration of checker discoverable. More...
void | registerMatchers (ast_matchers::MatchFinder *Finder) override
| Match common cases, where the owner semantic is relevant, like function calls, delete expressions and others. More...
void | check (const ast_matchers::MatchFinder::MatchResult &Result) override
| `ClangTidyChecks` that register ASTMatchers should do the actual work in here. More...
Public Member Functions inherited from clang::tidy::ClangTidyCheck
| ClangTidyCheck (StringRef CheckName, ClangTidyContext *Context)
| Initializes the check with `CheckName` and `Context`. More...
virtual void | registerPPCallbacks (CompilerInstance &Compiler)
| Override this to register `PPCallbacks` with `Compiler`. More...
DiagnosticBuilder | diag (SourceLocation Loc, StringRef Description, DiagnosticIDs::Level Level=DiagnosticIDs::Warning)
| Add a diagnostic with the check's name. More...

## Additional Inherited Members
Protected Member Functions inherited from clang::tidy::ClangTidyCheck
StringRef | getCurrentMainFile () const
| Returns the main file name of the current translation unit. More...
LangOptions | getLangOpts () const
| Returns the language options from the context. More...
Protected Attributes inherited from clang::tidy::ClangTidyCheck
OptionsView | Options

## Detailed Description

Checks for common use cases for gsl::owner and enforces the unique owner nature of it whenever possible.

For the user-facing documentation see: http://clang.llvm.org/extra/clang-tidy/checks/cppcoreguidelines-owning-memory.html

Definition at line 24 of file OwningMemoryCheck.h.

## Constructor & Destructor Documentation

## ◆ OwningMemoryCheck()

clang::tidy::cppcoreguidelines::OwningMemoryCheck::OwningMemoryCheck | ( | StringRef | Name,
|  | ClangTidyContext * | Context
| ) |  |
| inline

Definition at line 26 of file OwningMemoryCheck.h.

References registerMatchers(), and storeOptions().

## Member Function Documentation

## ◆ check()

void clang::tidy::cppcoreguidelines::OwningMemoryCheck::check | ( | const ast_matchers::MatchFinder::MatchResult & | Result | ) |
| override virtual

`ClangTidyChecks` that register ASTMatchers should do the actual work in here.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 182 of file OwningMemoryCheck.cpp.

## ◆ registerMatchers()

void clang::tidy::cppcoreguidelines::OwningMemoryCheck::registerMatchers | ( | ast_matchers::MatchFinder * | Finder | ) |
| override virtual

Match common cases, where the owner semantic is relevant, like function calls, delete expressions and others.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 42 of file OwningMemoryCheck.cpp.

Referenced by OwningMemoryCheck().

## ◆ storeOptions()

void clang::tidy::cppcoreguidelines::OwningMemoryCheck::storeOptions | ( | ClangTidyOptions::OptionMap & | Opts | ) |
| override virtual

Make configuration of checker discoverable.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 35 of file OwningMemoryCheck.cpp.

Referenced by OwningMemoryCheck().

The documentation for this class was generated from the following files:

- OwningMemoryCheck.h
- OwningMemoryCheck.cpp